#
# Sony CONFIDENTIAL
#
# Copyright 2006-2009 Sony Corporation.
#
# DO NOT COPY AND/OR REDISTRIBUTE WITHOUT PERMISSION.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.

#################################################
# common rules for scfs programs.
#################################################

BUILD_DIR_HOST		= build/host
BUILD_DIR_TARGET	= build/target

TOOL_PLUGIN_PREFIX	= scfs_
TOOL_PLUGIN_LIB_NAME	= lib$(TOOL_PLUGIN_PREFIX)$(notdir $(shell pwd)).so

ifdef SCFS_GPL_TOP
	TOP_DIR=$(SCFS_GPL_TOP)
else
	TOP_DIR=$(SCFS_TOP)
endif

ifeq ($(CONFIG_TARGET),y)
	TOOL_CROSS      = $(CROSS)
	TOOL_INSTROOT   = $(INSTROOT)
	TOOL_CFLAGS     = $(TARGET_TOOL_CFLAGS)
	TARGET_MOD_DIR  = $(shell echo $(TOOL_CROSS) | sed s/-$$//)
	BUILD_TOP	= $(TOP_DIR)/$(BUILD_DIR_TARGET)
else
	TOOL_CROSS	=
	TOOL_INSTROOT	=
	TOOL_CFLAGS	= $(HOST_TOOL_CFLAGS)
	TARGET_MOD_DIR  = .
	BUILD_TOP	= $(TOP_DIR)/$(BUILD_DIR_HOST)
endif

SCFS_CONFIG-$(CONFIG_SCFS_PROC)	+= -DCONFIG_SCFS_PROC
SCFS_CONFIG-$(CONFIG_SCFS_EAGER_PAGECACHE)		\
	+= -DCONFIG_SCFS_EAGER_PAGECACHE
SCFS_CONFIG-$(CONFIG_SCFS_EAGER_PAGECACHE_DEFAULT)	\
	+= -DCONFIG_SCFS_EAGER_PAGECACHE_DEFAULT

SCFS_CONFIG = $(SCFS_CONFIG-y)
